// Package publishserviceapi provides primitives to interact with the openapi HTTP API.
//
// Code generated by github.com/deepmap/oapi-codegen version v1.10.1 DO NOT EDIT.
package publishserviceapi

import (
	"bytes"
	"compress/gzip"
	"encoding/base64"
	"fmt"
	"net/http"
	"net/url"
	"path"
	"strings"

	"github.com/deepmap/oapi-codegen/pkg/runtime"
	"github.com/getkin/kin-openapi/openapi3"
	"github.com/labstack/echo/v4"
	externalRef0 "oransc.org/nonrtric/plt/capif/internal/readonly/common"
	externalRef1 "oransc.org/nonrtric/plt/capif/internal/readonly/common29571"
	externalRef2 "oransc.org/nonrtric/plt/capif/internal/readonly/nlfm"
)

// ServerInterface represents all server handlers.
type ServerInterface interface {

	// (GET /{apfId}/service-apis)
	GetApfIdServiceApis(ctx echo.Context, apfId ApfId) error

	// (POST /{apfId}/service-apis)
	PostApfIdServiceApis(ctx echo.Context, apfId ApfId) error

	// (DELETE /{apfId}/service-apis/{serviceApiId})
	DeleteApfIdServiceApisServiceApiId(ctx echo.Context, apfId ApfId, serviceApiId ServiceApiId) error

	// (GET /{apfId}/service-apis/{serviceApiId})
	GetApfIdServiceApisServiceApiId(ctx echo.Context, apfId ApfId, serviceApiId ServiceApiId) error

	// (PATCH /{apfId}/service-apis/{serviceApiId})
	ModifyIndAPFPubAPI(ctx echo.Context, apfId ApfId, serviceApiId ServiceApiId) error

	// (PUT /{apfId}/service-apis/{serviceApiId})
	PutApfIdServiceApisServiceApiId(ctx echo.Context, apfId ApfId, serviceApiId ServiceApiId) error
}

// ServerInterfaceWrapper converts echo contexts to parameters.
type ServerInterfaceWrapper struct {
	Handler ServerInterface
}

// GetApfIdServiceApis converts echo context to params.
func (w *ServerInterfaceWrapper) GetApfIdServiceApis(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "apfId" -------------
	var apfId ApfId

	err = runtime.BindStyledParameterWithLocation("simple", false, "apfId", runtime.ParamLocationPath, ctx.Param("apfId"), &apfId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter apfId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetApfIdServiceApis(ctx, apfId)
	return err
}

// PostApfIdServiceApis converts echo context to params.
func (w *ServerInterfaceWrapper) PostApfIdServiceApis(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "apfId" -------------
	var apfId ApfId

	err = runtime.BindStyledParameterWithLocation("simple", false, "apfId", runtime.ParamLocationPath, ctx.Param("apfId"), &apfId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter apfId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PostApfIdServiceApis(ctx, apfId)
	return err
}

// DeleteApfIdServiceApisServiceApiId converts echo context to params.
func (w *ServerInterfaceWrapper) DeleteApfIdServiceApisServiceApiId(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "apfId" -------------
	var apfId ApfId

	err = runtime.BindStyledParameterWithLocation("simple", false, "apfId", runtime.ParamLocationPath, ctx.Param("apfId"), &apfId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter apfId: %s", err))
	}

	// ------------- Path parameter "serviceApiId" -------------
	var serviceApiId ServiceApiId

	err = runtime.BindStyledParameterWithLocation("simple", false, "serviceApiId", runtime.ParamLocationPath, ctx.Param("serviceApiId"), &serviceApiId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter serviceApiId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.DeleteApfIdServiceApisServiceApiId(ctx, apfId, serviceApiId)
	return err
}

// GetApfIdServiceApisServiceApiId converts echo context to params.
func (w *ServerInterfaceWrapper) GetApfIdServiceApisServiceApiId(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "apfId" -------------
	var apfId ApfId

	err = runtime.BindStyledParameterWithLocation("simple", false, "apfId", runtime.ParamLocationPath, ctx.Param("apfId"), &apfId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter apfId: %s", err))
	}

	// ------------- Path parameter "serviceApiId" -------------
	var serviceApiId ServiceApiId

	err = runtime.BindStyledParameterWithLocation("simple", false, "serviceApiId", runtime.ParamLocationPath, ctx.Param("serviceApiId"), &serviceApiId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter serviceApiId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.GetApfIdServiceApisServiceApiId(ctx, apfId, serviceApiId)
	return err
}

// ModifyIndAPFPubAPI converts echo context to params.
func (w *ServerInterfaceWrapper) ModifyIndAPFPubAPI(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "apfId" -------------
	var apfId ApfId

	err = runtime.BindStyledParameterWithLocation("simple", false, "apfId", runtime.ParamLocationPath, ctx.Param("apfId"), &apfId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter apfId: %s", err))
	}

	// ------------- Path parameter "serviceApiId" -------------
	var serviceApiId ServiceApiId

	err = runtime.BindStyledParameterWithLocation("simple", false, "serviceApiId", runtime.ParamLocationPath, ctx.Param("serviceApiId"), &serviceApiId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter serviceApiId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.ModifyIndAPFPubAPI(ctx, apfId, serviceApiId)
	return err
}

// PutApfIdServiceApisServiceApiId converts echo context to params.
func (w *ServerInterfaceWrapper) PutApfIdServiceApisServiceApiId(ctx echo.Context) error {
	var err error
	// ------------- Path parameter "apfId" -------------
	var apfId ApfId

	err = runtime.BindStyledParameterWithLocation("simple", false, "apfId", runtime.ParamLocationPath, ctx.Param("apfId"), &apfId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter apfId: %s", err))
	}

	// ------------- Path parameter "serviceApiId" -------------
	var serviceApiId ServiceApiId

	err = runtime.BindStyledParameterWithLocation("simple", false, "serviceApiId", runtime.ParamLocationPath, ctx.Param("serviceApiId"), &serviceApiId)
	if err != nil {
		return echo.NewHTTPError(http.StatusBadRequest, fmt.Sprintf("Invalid format for parameter serviceApiId: %s", err))
	}

	// Invoke the callback with all the unmarshalled arguments
	err = w.Handler.PutApfIdServiceApisServiceApiId(ctx, apfId, serviceApiId)
	return err
}

// This is a simple interface which specifies echo.Route addition functions which
// are present on both echo.Echo and echo.Group, since we want to allow using
// either of them for path registration
type EchoRouter interface {
	CONNECT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	DELETE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	GET(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	HEAD(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	OPTIONS(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PATCH(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	POST(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	PUT(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
	TRACE(path string, h echo.HandlerFunc, m ...echo.MiddlewareFunc) *echo.Route
}

// RegisterHandlers adds each server route to the EchoRouter.
func RegisterHandlers(router EchoRouter, si ServerInterface) {
	RegisterHandlersWithBaseURL(router, si, "")
}

// Registers handlers, and prepends BaseURL to the paths, so that the paths
// can be served under a prefix.
func RegisterHandlersWithBaseURL(router EchoRouter, si ServerInterface, baseURL string) {

	wrapper := ServerInterfaceWrapper{
		Handler: si,
	}

	router.GET(baseURL+"/:apfId/service-apis", wrapper.GetApfIdServiceApis)
	router.POST(baseURL+"/:apfId/service-apis", wrapper.PostApfIdServiceApis)
	router.DELETE(baseURL+"/:apfId/service-apis/:serviceApiId", wrapper.DeleteApfIdServiceApisServiceApiId)
	router.GET(baseURL+"/:apfId/service-apis/:serviceApiId", wrapper.GetApfIdServiceApisServiceApiId)
	router.PATCH(baseURL+"/:apfId/service-apis/:serviceApiId", wrapper.ModifyIndAPFPubAPI)
	router.PUT(baseURL+"/:apfId/service-apis/:serviceApiId", wrapper.PutApfIdServiceApisServiceApiId)

}

// Base64 encoded, gzipped, json marshaled Swagger object
var swaggerSpec = []string{

	"H4sIAAAAAAAC/+xa4XLbuBF+FQzbmcZTmrJkO7nonyLLPl1yNmvKN9M5ZzwQuRJxIQEWAOWoGT1QX6NP",
	"1gFAUhQFS7KVJtee/tiSACx2F7v77S7wxQlZmjEKVAqn+8URYQwp1h97MPnAQiwJo+prBCLkJDNfnVEM",
	"KClGEaETxlPz+RV4Uw+FZEZChKOIgxAuuvIDFDLGI0KxBOGiCEuMQqASOBpeHKHHGDggGQPqDS5RxtmM",
	"RIRO9S8C+IyEgHr+EBFhdoXIc1wn4ywDLglofvWevSji6sufOUwUm0Hn7fmbzsN1kk4eSmm8OU6TP7WW",
	"grcKqVv9kgQI4SxcJwqH0brswwioJBMCQvNXl+Vlcsh5Bk7XEZITOlX7ToH1OOCXC3IFbMpxFpNQ01ks",
	"qk3Y+DcIpdqkBxOfswlJYF3EW8g4CEWyLoyaq8VdVz6GyUZVccQmhpQ/RPA5Y0KpZZLTUM+06ACvml+h",
	"B6u0dUtVp4YlvtQGuW3hxXKmWsdSTOg1Ti0KudBjSDL0GJMw1mKMIWF0KpBkNv6JMogJDuFiSUhYNFRO",
	"QxFITBLhuA6RkIptvA8t9NW+KaFDs75dcYU5x3M1mHEmWciSbcT9ct7CdQSEOSdy/jPImEUWEYJiAkrN",
	"DCTyLGNcQoTG89J+dhUrWNltq0Az4MKuWHVCxeiue/9STN+86cJ1OPwjJxwip/trYfk1Tj5afK3P0jSn",
	"xNjoSI82+fWZEGScAJrhJAeBMAd0jG4Hf7sbBKOH20Hg31wHgy5SkTesk1PBpHAutS9SzIGQxxxExqhQ",
	"VIK7d0H/dvhu8HB9Mxpe/n0HKiIfK+7GcEyZJJP5vdIi0DxVMje5clynuUVNDUuf6OdCsvQmA/4ErDTi",
	"Tm1QMYdRqAkgVlKwoABL01LBm856/UQWrqPI32T2CECkUpEAibBAX5YzFyjDXJa6u7sdIiF5HsqcA5ow",
	"bmEaPRIZs1wiDoLlPASEhWAhMYNYoAgmhEKECFXHECY4F4DOvDO1yemV76NRgDpvvfOTthU9VvheA274",
	"LJt6VYw3mbQRrgZtQaDy+R9HI78KBUoDZdgvxfXQDU3mCGdZQkKsTP4xBqqnlfFJib7EJ0RopE4KhCbu",
	"7erPS0N7lkdXJrRiEDa3vlhBml38+afg5rqLfsIzHOi56EYTQ9dMak5X3ExNtvqRNfY/15moOpS/CFQB",
	"1bozkWx2Zsmo2p3Og/IfRpUCns5ChuVyBYfZ7PV+pF6XpJSdvZCMr5Z+HUyr1OYiIpHEn5T1QggR0BAQ",
	"mwEvsr4GIZMUGu9emrhbeIoKMRmEZELC1YP5+uBpywk3hGa7PV8NRl3j8VeDUSEjOkb+TVD+rj7WBu6q",
	"3+/qP/dG/R/LAfV5OXQx+DAYDYox86UYXPGVq8HIcR21mfp3p/8qQo7rmEVWR/Jr+dAu4iomHtoP7YKd",
	"AvNR22uXg53GUGeFy3K945qPHTtX+TghIoaolxEfy3ira2flAh1nMyxjjTHEBFWBU0D9nj8sKxLgyOS6",
	"FvgMJ0ObP/RQQoRGuX7/EpEqrRe1kqdR4OCEA47mS+ZWzHhN6Gda6m0BJttrlxryPFG8/C/kDGWKAJE+",
	"WoTr2cN3yRjqiv0jZQsqWTCs2Q+9tExE1bBFMTkntlUJlmRmrMGiYY0yNWPCGQkKoCg3vOPEx1xuMq59",
	"TaWRKa0owq0nTkpGW8bUQKgdw64fvO+iBiSjNnp1p7sIow/BsR+8PzLSmapFy1eKc3rqtTsdRef9cJ1O",
	"p6Tjvx/uQOOmdzf6cZ3KKXo1+hAY37zp5TJGkn0Cuo3gCjr4wXsFW++HjuvobazoEJgw2/OH+2R/K9Ea",
	"ixqElDW7f2lt8xReZsOIWpeo1hJ0i5YJoWGSR0XTTLeACrwqGh9F67B06qOdHbfWyNrmuTgjtjaVRqxl",
	"qwoLQaZ0qQqDnSFT0bnoWCHJGshb06eHghgnCaJMorFOC9U5oAKOl1lRUamjCWdp5fAFxXp7rNzMwke5",
	"1eZtikZAtc8GgZ5iAdNohbJK955NmNAZ+wQcvYqICFWKPFc/H1kxCWfEHl8VIRVaLRFxG7buj5Qq7OZZ",
	"dglYirX2bHunGqTCPkUk56A7zTrvWpfVps+loX5VLLfRyvJxLQXd2DBspqy6yCoDVR9LmDI+tyZ+IsYc",
	"FLAP6YRtrXDqk4sAo4msKfWrHU6z31fYpR3dLKHZxzLcIYXHHKcgVUYtWRUZ1EjKIoXyeKVwv2zk/FW2",
	"tC1k/xci6sEhfncOYauYrDMt9xFl8vwYg4yrLkYtWaBRi63/HBYioRBTBUdaiqiM/lX1aCtDhaUkwxlR",
	"Nji7YKkl1fiwkdzymmatLK3dVEq2ZPPFpanrEFEp1tZGkmqfe0fyHO6dWmkiYyy/gWrrEnvoRh3oIxGg",
	"QVMzNsGJgHun5jljxhLAdC3w1QW1Bb/y9mSXgrzsjtS5W49cGXmSpiKS4t8Yr5HSYG+SyFn7yOa+pgJ/",
	"uiztN6pusbFVv3OC2rz22GZS8DkjJja8oMV5gSWMSAr1QlU8XaXabuv84c6iVW2Y592ZLU/WZkk423iZ",
	"vITCDQmrFQrKAGyvAgI9r4STufqMqXbZGYlynDyR7FuqZH2GEjjFyQULLdqvZZqdTgf90n7jnXknyJyv",
	"FulSpQOPjH/STRE9/5pxGY9ZTjXkC11lJ07XiaXMRLfVenx89E6nWeYxPm1NZNYKMghFC/MwJjNodd4+",
	"COAERMvs2jK31AZi1r1LbVvTa01i4SF0T//9L9Q56XRcw9sNn2JK/qlPBifIx1xSlcu86t0O37moNxoG",
	"Lur3g56LBqNg6KJRcKH/jXrqT/9I0+wlCeJkGkuhHA74DCJPV8iSSBVeDfw/FNj6UKRbDwasy8vertP2",
	"Ot7JMU6yGHtnRSuK4owoxXsn3omKNFjG+lxaX7S1LVqFgMc4I3pgCtLmNZITmAFSNddKBqYxrAocyryc",
	"K5A9RTuorE7onctEz+n++sUhiqzixnEd3TDqFuZf9xiFHm7xNmebR5rVi8VH7f66PtPydE5OTK+TSqDS",
	"xFfdUlP8tn4TJsou99jxwsHWi1isuX8zDXMuVBlGqpQ2SeoG9koc2foRT/j5wnVOT948M1pWqmmptZrE",
	"D3uQ+EGRODMafhEJtVaTaO9Bom1InO5B4tSQONuDxJkh8XoPEq81ic7bl5PovFUkzvc4kXNzIud7qPPc",
	"qDOCCc4T+WIy5XrtRhkTtstm4xgIIwqPJSqtRiOfie8ejnRR+45F82dFohcEoNWEQ/G7WAuH7W/BRLMc",
	"WCb1tWQiD0MQYpInyVw/zKldAYQc9J1PlX+Kst3HQea86GSpmfdO+Qbu3jEtuhhwZGpi80nL/fSTzj6j",
	"0lRPqyxQeEzma4y4CIehftE5LQuRqs/W1c24W8bkolWJqYG1NWtbAbf1pZ6aLTZa21qydQi9q6G3vYcg",
	"bSNIew9B2kaQ9vkeJM4PAGAHgIXr7ORA2rsTkJaexB3NKrR4sqJZxY4LTaqJHkG9mtoFScTqgpcBygqR",
	"xcL9pin0mf0l/LYaEaVYhnHjIXjPJ8MIEYHMQUWHTPb3GU4PUciShm6pjncNLJYS+Q8YVU6+fSa6Wn/X",
	"4pewpqiHGvxQgx+CX1WD2290f2YRmcwRpgg+EyGVh+wYBs3KIY16/qWfj00/8/808u3SA0iBT+FYq/mv",
	"XyEAmhv4nZoC3yEUj/TrrHo4tjymNY8Ams0CTCP9ELS4X1u5F8mzSBfsDULNtkH50mDMormO49Yk95qh",
	"vlGKh17O7wEnDg2DQ8Pgm6KV60g8VQCiH3YUOd7a8yHno37bYknp73QU2T2h9/M/aEL/u2ptf/eCoo4G",
	"FRA1kWAL0hzA4gAWB7D4tt3l4o1MGZzN+5INlzmO68wwJ3icVE+21Ezj1gVb1fsU+IzTLAEvZKnTDB/F",
	"widfaL/xzhsvtDudjqd4/rj4TwAAAP//KyCX7MREAAA=",
}

// GetSwagger returns the content of the embedded swagger specification file
// or error if failed to decode
func decodeSpec() ([]byte, error) {
	zipped, err := base64.StdEncoding.DecodeString(strings.Join(swaggerSpec, ""))
	if err != nil {
		return nil, fmt.Errorf("error base64 decoding spec: %s", err)
	}
	zr, err := gzip.NewReader(bytes.NewReader(zipped))
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}
	var buf bytes.Buffer
	_, err = buf.ReadFrom(zr)
	if err != nil {
		return nil, fmt.Errorf("error decompressing spec: %s", err)
	}

	return buf.Bytes(), nil
}

var rawSpec = decodeSpecCached()

// a naive cached of a decoded swagger spec
func decodeSpecCached() func() ([]byte, error) {
	data, err := decodeSpec()
	return func() ([]byte, error) {
		return data, err
	}
}

// Constructs a synthetic filesystem for resolving external references when loading openapi specifications.
func PathToRawSpec(pathToFile string) map[string]func() ([]byte, error) {
	var res = make(map[string]func() ([]byte, error))
	if len(pathToFile) > 0 {
		res[pathToFile] = rawSpec
	}

	pathPrefix := path.Dir(pathToFile)

	for rawPath, rawFunc := range externalRef0.PathToRawSpec(path.Join(pathPrefix, "TS29122_CommonData.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	for rawPath, rawFunc := range externalRef1.PathToRawSpec(path.Join(pathPrefix, "TS29571_CommonData.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	for rawPath, rawFunc := range externalRef2.PathToRawSpec(path.Join(pathPrefix, "TS29572_Nlmf_Location.yaml")) {
		if _, ok := res[rawPath]; ok {
			// it is not possible to compare functions in golang, so always overwrite the old value
		}
		res[rawPath] = rawFunc
	}
	return res
}

// GetSwagger returns the Swagger specification corresponding to the generated code
// in this file. The external references of Swagger specification are resolved.
// The logic of resolving external references is tightly connected to "import-mapping" feature.
// Externally referenced files must be embedded in the corresponding golang packages.
// Urls can be supported but this task was out of the scope.
func GetSwagger() (swagger *openapi3.T, err error) {
	var resolvePath = PathToRawSpec("")

	loader := openapi3.NewLoader()
	loader.IsExternalRefsAllowed = true
	loader.ReadFromURIFunc = func(loader *openapi3.Loader, url *url.URL) ([]byte, error) {
		var pathToFile = url.String()
		pathToFile = path.Clean(pathToFile)
		getSpec, ok := resolvePath[pathToFile]
		if !ok {
			err1 := fmt.Errorf("path not found: %s", pathToFile)
			return nil, err1
		}
		return getSpec()
	}
	var specData []byte
	specData, err = rawSpec()
	if err != nil {
		return
	}
	swagger, err = loader.LoadFromData(specData)
	if err != nil {
		return
	}
	return
}
